




function [ c ceq ]= GLOBAL_CONST( x,Dmin,Kmax,FOR_LOOP_LIST )
% constraints function for global optimization


ceq = [];  % no equality constraints

N = size(x,1) /3 ;
path = reshape(x,N,3);

path_PARAMS = compute_linear_params( path );


% % CURVATURE CONSTRAINT ( K = d||T||/dS )
% dS = sqrt( sum( abs( path(2:end,:) - path(1:end-1,:) ).^2,2 ) );
% 
% T = path(2:end,:) - path(1:end-1,:);  % tangent vector
% Tnorm = sqrt( sum( abs(T).^2,2 ) );
% T = T ./ repmat(Tnorm,[1 3]);  % normalize (unit vector)
% 
% K = T(2:end,:) - T(1:end-1,:);
% K = K ./ repmat(dS(1:end-1),[1 3]);  % K = dT/dS
% Knorm_SQ = sum( abs(K).^2,2 );
% 
% Knorm_CONST = Knorm_SQ  -  Kmax^2;
    
    
% DISTANCE CONSTRAINTS

Npairs = size( FOR_LOOP_LIST,1 );
Dist_CONST = zeros( Npairs,1 );

for ii = 1 : Npairs
    
    seg1 = FOR_LOOP_LIST(ii,1);
    seg2 = FOR_LOOP_LIST(ii,2);
    
    alpha1 = path_PARAMS.alphas( seg1,: );
    alpha2 = path_PARAMS.alphas( seg2,: );
    
    beta1 = path_PARAMS.betas( seg1,: );
    beta2 = path_PARAMS.betas( seg2,: );
    
    t10 = 0.5;
    t20 = 0.5;

    T = distance_seg2seg( alpha1,beta1,alpha2,beta2,t10,t20 );
    
    XX1 = alpha1 * T(1)  +  beta1;
    XX2 = alpha2 * T(2)  +  beta2;
    
    DIST = norm( XX1-XX2 );
    
    Dist_CONST(ii) = Dmin^2  -   DIST.^2;
    
end



% CONCATENATE ALL CONSTRAINTS

% c = [ Knorm_CONST ; Dist_CONST ];
c = [ Dist_CONST ];








