




function [ DCP2SEG C_COMB ]= print_path_constraints_par( x,Dmin,Kmax,Nrej,string2print,FOR_LOOP_LIST )


N = size(x,1) /3 ;
path = reshape(x,N,3);

path_PARAMS = compute_linear_params( path );

Nseg = N-1;
DCP2SEG = -ones( Nseg,Nseg );

figure; subplot(2,2,1); plot3( path(:,1),path(:,2),path(:,3),'-ok','LineWidth',2 );
axis image; hold on;

colors = 'rbgmcy';
Ncolors = size(colors,2);

Npairs = size( FOR_LOOP_LIST,1 );

TEMP = zeros( Npairs,1 );
XX1 = zeros(Npairs,3);
XX2 = zeros(Npairs,3);

parfor ii = 1 : Npairs
    
    seg1 = FOR_LOOP_LIST(ii,1);
    seg2 = FOR_LOOP_LIST(ii,2);
    
    alpha1 = path_PARAMS.alphas( seg1,: );
    alpha2 = path_PARAMS.alphas( seg2,: );
    
    beta1 = path_PARAMS.betas( seg1,: );
    beta2 = path_PARAMS.betas( seg2,: );
    
    t10 = 0.5;
    t20 = 0.5;

    T = distance_seg2seg( alpha1,beta1,alpha2,beta2,t10,t20 );
    
    XX1(ii,:) = alpha1 * T(1)  +  beta1;
    XX2(ii,:) = alpha2 * T(2)  +  beta2;
    
    DIST = norm( XX1(ii,:)-XX2(ii,:) );
    
    TEMP(ii) = DIST;
    
    seg_max = max( seg1,seg2 );
    seg_min = min( seg1,seg2 );
      
end


DCP2SEG( FOR_LOOP_LIST(:,3) ) = TEMP;

for ii = 1:Npairs
    
    seg1 = FOR_LOOP_LIST(ii,1);
    seg2 = FOR_LOOP_LIST(ii,2);

    seg_max = max( seg1,seg2 );
    seg_min = min( seg1,seg2 );
    
    if seg_max > seg_min + (Nrej-1)  && TEMP(ii) < Dmin
        xxx = [ XX1(ii,1);XX2(ii,1) ];
        yyy = [ XX1(ii,2);XX2(ii,2) ];
        zzz = [ XX1(ii,3);XX2(ii,3) ];
        eval( sprintf( 'plot3( xxx,yyy,zzz,''-%s'' );',colors(mod(ii-1,Ncolors)+1) ) );
    end

end


ONES = -ones( Nseg,Nseg );
DCP2SEG = full( spdiags(ONES,[0:Nrej-1],DCP2SEG) );

title( sprintf('%s',string2print) );

subplot(2,2,2);
imagesc(DCP2SEG); axis image; colorbar;
title( sprintf('SEGMENT DISTANCE MATRIX (%s)',string2print) ); 
xlabel('SEGMENT #'); ylabel('SEGMENT #');

C_min = min( DCP2SEG(:) );
C_max = max( DCP2SEG(:) );

nCmap = 256;

n1 = int32( ( 0 - C_min ) / ( C_max - C_min ) * nCmap );
n2 = int32( ( Dmin - 0 ) / ( C_max - C_min ) * nCmap );
n3 = int32( ( C_max - Dmin ) / ( C_max - C_min ) * nCmap );

while ( n1+n2+n3 ) > nCmap
    n3 = n3 - 1;
end

while ( n1+n2+n3 ) < nCmap
    n3 = n3 + 1;
end

C_gray = colormap( gray(256) );
C_hot = colormap( jet(256) );

C_COMB = [ zeros(n1,3) ; interp1( linspace(0,1,nCmap)',C_hot,linspace(0,1,n2) ) ; interp1( linspace(0,1,nCmap)',C_gray,linspace(0,1,n3) ) ];  % combine hot and gray scales
       
colormap( C_COMB );

    


% CURVATURE
dS = sqrt( sum( abs( path(2:end,:) - path(1:end-1,:) ).^2,2 ) );

T = path(2:end,:) - path(1:end-1,:);  % tangent vector
Tnorm = sqrt( sum( abs(T).^2,2 ) );
T = T ./ repmat(Tnorm,[1 3]);  % normalize (unit vector)

K = T(2:end,:) - T(1:end-1,:);
K = K ./ repmat(dS(1:end-1),[1 3]);  % K = dT/dS
Knorm = sqrt( sum( abs(K).^2,2 ) );
subplot(2,2,3);
plot( Knorm,'-ob' ); hold on;

x = [ 1 : Nseg-1 ]';
y = ones(Nseg-1,1) * Kmax;

plot(x,y,'-r','LineWidth',2);

xlabel('SEGMENT #'); title( sprintf('CURVATURE (%s)',string2print) );

legend('K','Kmax');

axis([ 1 Nseg-1  0 max([Kmax ; Knorm])*1.2 ]);

save PATH_ANALYSIS.mat path FOR_LOOP_LIST Npairs Dmin TEMP DCP2SEG C_COMB Knorm Kmax XX1 XX2;









