




function [ DIST PT1 PT2 ] = distance_seg2AllSegs( path_PARAMS,segIndex,FLAG )
% FLAG == -1: compute distance between segIndex and 1...segIndex
% FLAG == 0: compute distance between segIndex and all segments (1...N)
% FLAG == +1: compute distance between segIndex...N
% compute distance between segIndex and all the segments of the path

N = size(path_PARAMS.alphas,1);
DIST = zeros(N,1);
   
t10 = 0.5;
t20 = 0.5;    

p_SEG1.alpha = path_PARAMS.alphas( segIndex,: );
p_SEG1.beta = path_PARAMS.betas( segIndex,: );

% note that the distance between segIndex and segIndex is 0
%                                segIndex and segIndex-1 is 0
%                                segIndex and segIndex+1 is 0
if FLAG == -1
    indStart = 1;
    indEnd = segIndex - 2;
elseif FLAG == 1
    indStart = segIndex + 2;
    indEnd = N;
else
    indStart = 1;
    indEnd = N;
end    

if nargout>1
    PT1 = zeros(N,3);
    PT2 = zeros(N,3);
end

for jj = indStart : indEnd

    if abs( jj-segIndex ) > 1
        
        p_SEG2.alpha = path_PARAMS.alphas( jj,: );
        p_SEG2.beta = path_PARAMS.betas( jj,: );

        T = distance_seg2seg( p_SEG1.alpha,p_SEG1.beta,p_SEG2.alpha,p_SEG2.beta,t10,t20 );

        XX1 = T(1) .* p_SEG1.alpha  +  p_SEG1.beta;
        XX2 = T(2) .* p_SEG2.alpha  +  p_SEG2.beta;

        DIST(jj) = norm( XX1 - XX2 );
        
        if nargout > 1
            PT1( jj,: ) = XX1;
            PT2( jj,: ) = XX2;
        end

        t10 = T(1);
        t20 = T(2);
    end
    
end






