



function T = distance_seg2seg( alpha1,beta1,alpha2,beta2,t10,t20 )
% compute distance between segments SEG1 and SEG2

X = alpha1;
x = alpha2;
DY = beta1 - beta2;

AA = norm(X)^2;
BB = norm(x)^2;
CC = -2 * dot(X,x);
DD = 2 * dot( X,DY );
EE = -2 * dot(x,DY);
FF = norm( DY )^2;

HESS = [ 2*AA  CC    ;
         CC     2*BB ];
     
LINTERM = [ DD ; EE ];

% make sure starting point is feasible
t10 = min( t10,1 );
t10 = max( t10,0 );

t20 = min( t20,1 );
t20 = max( t20,0 );

T0 = [ t10;t20 ];

LB = [0;0];
UB = [1;1];

OPTIONS = optimset( 'Algorithm','interior-point-convex', 'Display','none' , ...
                'MaxFunEvals',1e5 , 'MaxIter',50 , 'TolCon',1e-10 , 'TolFun',1e-10 );

[ T fval ] = quadprog( HESS,LINTERM,[],[],[],[],LB,UB,T0,OPTIONS );


% CI = [ 1.0 0.0 -1.0 0.0;
%         0.0 1.0 0.0 -1.0];
% CI0 = [0.0 0.0 1.0 1.0];
% 
% [ T fval ] = QUADPROG_mex( HESS,LINTERM,[],[],CI,CI0 )

fval = fval + FF;  % constant term FF is not taken into account in quadprog...

