

close all;


% segment #1
A = rand(1,3);
B = rand(1,3);

% segment #2
C = rand(1,3);
D = rand(1,3);

N = 30;
t1 = linspace(0,1,N);
t2 = linspace(0,1,N);

X = B - A;
Y = A;

x = D - C;
y = C;

%% PLOT

DD = zeros(N);
DD2 = zeros(N);

for ii = 1:N
        
    DD(ii,:) = norm(X)^2 * t1(ii).^2   +   norm(x)^2*t2.^2  ...
        - 2 * t1(ii).*t2 * dot(X,x)  +  2*t1(ii).*dot( X,Y-y )  -  2*t2.*dot(x,Y-y)  + norm( Y-y )^2;

%     PT1 = X * t1(ii) + Y;
%     for jj = 1:N        
%         PT2 = x * t2(jj) + y;
%         % DD2( ii,jj ) = norm(PT1-PT2)^2;
%         DD2( ii,jj ) = FUN( [t1(ii);t2(jj)] );
%     end
    
end

f = figure;
surf( t1,t2,DD ); 

% f = figure;
% surf( t1,t2,DD2 ); 


%% FIND MINIMUM DISTANCE BY OPTIMIZATION

AA = norm(X)^2;
BB = norm(x)^2;
CC = -2 * dot(X,x);
DD = 2 * dot( X,Y-y );
EE = -2 * dot(x,Y-y);
FF = norm( Y-y )^2;

HESS = [ 2*AA  CC    ;
         CC     2*BB ];
     
LINTERM = [ DD ; EE ];

T0 = [1;1];

LB = [0;0];
UB = [1;1];

OPTIONS = optimset( 'Algorithm','interior-point-convex', 'Display','iter-detailed' , ...
                'MaxFunEvals',1e5 , 'MaxIter',50 , 'TolCon',1e-6 , 'TolFun',1e-6 );

[ T fval ] = quadprog( HESS,LINTERM,[],[],[],[],LB,UB,T0,OPTIONS );
fval = fval + FF;  % constant term FF is no taken into account in quadprog...


hold on;
plot3( T(2),T(1),fval,'-ok','LineWidth',2 );


f = figure;
TMP = [A;B];
plot3( TMP(:,1),TMP(:,2),TMP(:,3),'-o' );

TMP = [C;D];
hold on; plot3( TMP(:,1),TMP(:,2),TMP(:,3),'-or' ); axis image;
legend( 'SEG #1','SEG #2' );

PT1 = X * T(1) + Y;
PT2 = x * T(2) + y;

plot3( PT1(1),PT1(2),PT1(3),'-ok','LineWidth',2 );
plot3( PT2(1),PT2(2),PT2(3),'-ok','LineWidth',2 );







