


function prepare_GPU_kernels( path_PARAMS0,FOR_LOOP_LIST )

global gpuStruct;


nsegs0 = size( path_PARAMS0.alphas,1 );

if ~parallel.gpu.GPUDevice.isAvailable
    error('You selected to use the GPU, but it is not available.');
end

% grab GPU
gpuStruct.g=gpuDevice(1);


% GLOBAL_CONST
fprintf('Preparing constraint function GPU kernel ...\n');
gpuStruct.GLOBAL_CONST = parallel.gpu.CUDAKernel('GLOBAL_CONST_CUDAKernel.ptx','GLOBAL_CONST_CUDAKernel.cu');

gpuStruct.npairs = size( FOR_LOOP_LIST,1 );

M=128;
N=max( ceil( gpuStruct.npairs / M ) , 1 );
gpuStruct.GLOBAL_CONST.ThreadBlockSize = M;
gpuStruct.GLOBAL_CONST.GridSize = N;

gpuStruct.DIST_CONST = gpuArray( zeros(gpuStruct.npairs,1) );

TEMP = FOR_LOOP_LIST(:,1:2)';
gpuStruct.FOR_LOOP_LIST = gpuArray( int32(TEMP(:)) );

gpuStruct.ALPHAS = gpuArray( zeros(nsegs0*3,1) );
gpuStruct.BETAS = gpuArray( zeros(nsegs0*3,1) );



















