
function path = resample_path( path,N )
% function path = resample_path( path,N )
% resample path using cubic interpolation (N points)

path0 = path;

[ CS IND ]= unique( [ 0; cumsum( sqrt ( sum( diff(path0,[],1 ).^2,2 ) ) ) ] );

path = interp1( CS,path0(IND,:),linspace(0,CS(end),N),'PCHIP' );
% path = interp1( CS,path0,linspace(0,CS(end),N),'linear' );



