


close all;
clear;

fname = select_file('*.mat','./','SELECT DBS PATH CHAIN');
load(fname);
N = size(chain,1);


f = figure;
plot3( chain(:,1),chain(:,2),chain(:,3),'-ob' ); axis image; hold on;

plot3( chain(1,1),chain(1,2),chain(1,3),'ok','LineWidth',3 );
plot3( chain(end,1),chain(end,2),chain(end,3),'om','LineWidth',3 );

legend('CHAIN','0','1');

tip = int32( input( 'CHOOSE TIP TO ADD ELECTRODES TO [0/1]: ' ) );

if tip == 1
    chain = chain(end:-1:1,:);
end
chain0 = chain;

S = [ 0 ; cumsum( sqrt( sum( diff( chain,[],1).^2,2 ) ) ) ];


fprintf('COMPUTE PATH TO REMOVE END TIP CONDUCTIVE WIRE ...\n');

S2 = linspace(0,1.5,10);
chain = interp1(S,chain0,S2,'linear');

eval( sprintf('save %s_REMOVE_COND_TIP.mat chain;',fname(3:end-4)) );


fprintf('ADD 4 ELECTRODES PATH ...\n');
S1 = linspace( 1.5,3.0,10 );
S2 = linspace( 4.5,6.0,10 );
S3 = linspace( 7.5,9.0,10 );
S4 = linspace( 10.5,12.0,10 );

for ii =1 :4
    eval( sprintf('chain = interp1(S,chain0,S%d,''linear'');',ii) );
    eval( sprintf('save %s_ELECTR%d.mat chain;',fname(3:end-4),ii) );
end




























