

clear;

fname = select_file('*.mat','./','SELECT CHAIN MAT FILE TO BE SMOOTHED');
load(fname);

usampling = input('ENTER UNDERSAMPLING FACTOR OF ORIGINAL CHAIN: ');
osampling = input('ENTER OVERSAMPLING FACTOR OF ORIGINAL CHAIN: ');

% interpolate 3D curve using cubic splines
fprintf('SMOOTHING ...\n');

chain0 = chain;

% undersample path
N = size(chain,1);
M = ceil( N/usampling );  % # of point in the final interpolation
CS = cat(1,0,cumsum(sqrt(sum(diff(chain,[],1).^2,2))));
dd_under = interp1(CS, chain, linspace(0,CS(end),M),'cubic');

% extrapolate to initial size using cubic spline
P = ceil( N*osampling );
CS = cat(1,0,cumsum(sqrt(sum(diff(dd_under,[],1).^2,2))));
chain = interp1(CS, dd_under, linspace(0,CS(end),P),'cubic');

f = figure;
plot3( chain0(:,1),chain0(:,2),chain0(:,3),'-ob' ); hold on;
plot3( chain(:,1),chain(:,2),chain(:,3),'-or' );
axis image off;
legend('Original','Cubic smooth');

eval( sprintf('save %s_SMOOTH.mat chain',fname(3:end-4)) );






