


clear;

fname = select_file('*.mat','./','SELECT CHAIN MAT FILE #1');
fname2 = select_file('*.mat','./','SELECT CHAIN MAT FILE #2');

load(fname);
chain1 = chain;

load(fname2);
chain2 = chain;

rev = input('REVERSE FIRST CHAIN [1=yes / 0=no]: ');

if rev == 1
    chain = chain1(end:-1:1,:);
else
    chain = chain1;
end

% first point to stitch
A = chain(end,:);
TA = chain( end,: ) - chain( end-1 ,: );
TA = TA ./ repmat(norm(TA),[1 3 ]);

% second point to stitch
B = chain2(1,:);
TB = chain2( 2,: ) - chain2( 1 ,: );
TB = TB ./ repmat(norm(TB),[1 3]);

% manuall scale the tangents
TA = TA * 30;
TB = TB * 30;

alpha = TA+TB+2*A-2*B;   
beta = -TB - 2*TA + 3*B - 3*A;   
gamma = TA;  
eps = A; 

DIST = mean( sqrt( sum( (chain(2:end,:)-chain(1:end-1,:)).^2,2 ) ) );

DIST_ = norm(A-B);

t = linspace( 0,1,ceil(DIST_/DIST*1.1) )';  % cubic parameters
t(1) = [];
t(end) = [];

chainST = (t.^3)*alpha + (t.^2)*beta + t*gamma + ones(size(t))*eps;

chain = [ chain ; chainST ; chain2 ];

save STITCHED_CHAIN.mat chain;

chain = chainST;
save STITCHES.mat chain;

f = figure; 
plot3(chain1(:,1),chain1(:,2),chain1(:,3),'-ob','LineWidth',1); hold on;
plot3(chain2(:,1),chain2(:,2),chain2(:,3),'-or','LineWidth',1); hold on;
plot3(chainST(:,1),chainST(:,2),chainST(:,3),'-ok','LineWidth',1); hold on;
quiver3( A(1),A(2),A(3),TA(1),TA(2),TA(3),0,'LineWidth',2 );
quiver3( B(1),B(2),B(3),TB(1),TB(2),TB(3),0,'LineWidth',2 );
legend('chain #1', 'chain #2', 'stitches');
legend boxoff;
axis image off;






