


close all;
clear;

fname = select_file('*.mat','./','SELECT DBS PATH CHAIN');
load(fname);
N = size(chain,1);


f = figure;
plot3( chain(:,1),chain(:,2),chain(:,3),'-ob' ); axis off image; hold on;

plot3( chain(1,1),chain(1,2),chain(1,3),'ok','LineWidth',3 );
plot3( chain(end,1),chain(end,2),chain(end,3),'om','LineWidth',3 );

legend('CHAIN','0','1');

tip = int32( input( 'CHOOSE ELECTRODE TIP [0/1]: ' ) );

if tip == 1
    chain = chain(end:-1:1,:);
end
chain0 = chain;

S = [ 0 ; cumsum( sqrt( sum( diff( chain,[],1).^2,2 ) ) ) ];

seg2replace = find( S<15 );  % the electrode tip is 15 mm long
DIST = norm( chain(max(seg2replace),:) - chain(min(seg2replace),:) );

DIR_1 = max(seg2replace);
DIR_2 = max(seg2replace) + 3;  % compute the average linear direction over 3 segments
DIR = mean( chain(DIR_1+1:DIR_2,:) - chain(DIR_1:DIR_2-1,:),1 );
DIR = DIR ./ repmat( norm(DIR),[1 3] );

t = linspace( 0,1,numel(seg2replace) )';
newTip = -t * DIR * DIST +  repmat( chain( max(seg2replace),: ),[numel(seg2replace) 1] );

chain = chain0;
chain( seg2replace,: ) = newTip( end:-1:1,: );

eval( sprintf( 'save %s_STRAIGHT.mat chain;',fname(1:end-4) ) );


f = figure;
plot3( chain0(:,1),chain0(:,2),chain0(:,3),'-r' ); hold on;
plot3( chain(:,1),chain(:,2),chain(:,3),'-ok' );
axis image off;
legend('Initial chain','New tip');






















